/**
 * Date generation for parsing GD server responses
 * @internal
 * @packageDocumentation
 */
import { Duration } from 'duration-converter';
/**
 * Creates a date from the human-readable response returned by the Geometry Dash servers
 * @param pretty The pretty string to parse
 * @returns A date ready for use by a client
 * @internal
 */
const generateDate = (pretty) => {
    // Only on private servers will this work
    let date = new Date(pretty);
    if (!date.getTime())
        date = new Date(Date.now() - new Duration(pretty).MilliSeconds);
    return { pretty, date };
};
export { generateDate };
