/**
 * Parse the data from the server
 * @internal
 * @packageDocumentation
 */
/**
 * Converts the raw string response from a Geometry Dash server into key-value pairs.
 * @param data The data to parse
 * @param splitter The splitter for the data. Defaults to a colon
 * @returns The parsed data
 * @internal
 */
export const parse = (data, splitter = ':') => {
    const split = data.split(splitter);
    const obj = {};
    for (let i = 0; i < split.length; i += 2)
        obj[split[i]] = split[i + 1];
    return obj;
};
/**
 * Converts a raw object string into a JavaScript object.
 * @param data The object to parse
 * @returns The parsed object
 * @internal
 */
export const parseObject = (data) => {
    const split = data.split(',');
    const obj = {};
    // the majority
    for (let i = 0; i < split.length; i += 2)
        obj[split[i]] = +split[i + 1] || split[i + 1];
    return obj;
};
