"use strict";
/**
 * Encoding and decoding methods for the browser
 * @internal
 * @packageDocumentation
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.gdDecodeBase64 = exports.gdEncodeBase64 = void 0;
exports.gdEncodeBase64 = function (str) {
    return btoa(str)
        .replace(/\//g, '_')
        .replace(/\+/g, '-');
};
/**
 * Decode a string from Geometry Dash server-compatible Base64
 * @param str The string to decode from Geometry Dash Base64
 * @returns The original, unencoded string
 * @internal
 */
exports.gdDecodeBase64 = function (str) {
    return atob(str.replace(/_/g, '/').replace(/-/g, '+'));
};
