"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.gdDecodeBase64 = exports.gdEncodeBase64 = void 0;
/**
 * Encode a string in Geometry Dash server-compatible Base64
 * @param str The string to encode in Geometry Dash Base64
 * @returns The Geometry Dash Base64 string
 * @internal
 */
exports.gdEncodeBase64 = function (str) {
    return Buffer.from(str, 'latin1').toString('base64');
};
/**
 * Decode a string from Geometry Dash server-compatible Base64
 * @param str The string to decode from Geometry Dash Base64
 * @returns The original, unencoded string
 * @internal
 */
exports.gdDecodeBase64 = function (str) {
    return Buffer.from(str, 'base64').toString('latin1');
};
