"use strict";
/**
 * Date generation for parsing GD server responses
 * @internal
 * @packageDocumentation
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateDate = void 0;
var duration_converter_1 = require("duration-converter");
/**
 * Creates a date from the human-readable response returned by the Geometry Dash servers
 * @param pretty The pretty string to parse
 * @returns A date ready for use by a client
 * @internal
 */
var generateDate = function (pretty) {
    // Only on private servers will this work
    var date = new Date(pretty);
    if (!date.getTime())
        date = new Date(Date.now() - new duration_converter_1.Duration(pretty).MilliSeconds);
    return { pretty: pretty, date: date };
};
exports.generateDate = generateDate;
