"use strict";
/**
 * Parse the data from the server
 * @internal
 * @packageDocumentation
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseObject = exports.parse = void 0;
/**
 * Converts the raw string response from a Geometry Dash server into key-value pairs.
 * @param data The data to parse
 * @param splitter The splitter for the data. Defaults to a colon
 * @returns The parsed data
 * @internal
 */
exports.parse = function (data, splitter) {
    if (splitter === void 0) { splitter = ':'; }
    var split = data.split(splitter);
    var obj = {};
    for (var i = 0; i < split.length; i += 2)
        obj[split[i]] = split[i + 1];
    return obj;
};
/**
 * Converts a raw object string into a JavaScript object.
 * @param data The object to parse
 * @returns The parsed object
 * @internal
 */
exports.parseObject = function (data) {
    var split = data.split(',');
    var obj = {};
    // the majority
    for (var i = 0; i < split.length; i += 2)
        obj[split[i]] = +split[i + 1] || split[i + 1];
    return obj;
};
